Name "The Gas Free Zone"

# !include WinMessages.nsh
!include Sections.nsh

CRCCheck force
SetCompressor lzma

 Page license skipLicense
 Page components
 Page directory skipDirectory
 Page instfiles
 UninstPage uninstConfirm
 UninstPage instfiles

InstType "Setup"
InstType "Update"
InstType "Activate"
InstType "Deactivate"
InstType "Uninstaller"
# InstType /NOCUSTOM

# BGGradient 000000 662D91 662D91
LicenseBkColor 662D91
InstallColors 000000 662D91
BrandingText " "
Caption "The Gas Free Zone"
WindowIcon off
InstProgressFlags "smooth"
ShowInstDetails show
ShowUninstDetails show
InstallButtonText "Go!"
CompletedText " "
ComponentText "Please select an action from the list below:" " " " "
SubCaption 0 ": Information"
SubCaption 1 ": Setup Options"
SubCaption 3 ": Performing Action"
SubCaption 4 ": Action Result"

OutFile "GFZ.exe"

XPStyle on

LicenseText " " "Proceed"
LicenseData "Ack.rtf"

DirText "Please confirm your OP installation directory:"

Var is_installed

Section "Setup" g1o1
SectionIn 1

ReadRegStr $is_installed HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GFZ" "DisplayName"
StrCmp $is_installed "GFZ Setup" GFZ_installed GFZ_not_installed

GFZ_not_installed:

CreateDirectory "$INSTDIR\GFZ_files"

CreateDirectory "$INSTDIR\GFZ_files\backup"

CreateDirectory "$INSTDIR\GFZ_files\backup\Assets"

CreateDirectory "$INSTDIR\GFZ_files\backup\Assets\Specs"
CopyFiles "$INSTDIR\Assets\Specs\shiplist.txt" "$INSTDIR\GFZ_files\backup\Assets\Specs" 2911
CopyFiles "$INSTDIR\Assets\Specs\ftrlist.txt" "$INSTDIR\GFZ_files\backup\Assets\Specs" 29

CreateDirectory "$INSTDIR\GFZ_files\backup\MetaAssets"
CopyFiles "$INSTDIR\MetaAssets\shiplist.txt" "$INSTDIR\GFZ_files\backup\MetaAssets" 2911
CopyFiles "$INSTDIR\MetaAssets\ftrlist.txt" "$INSTDIR\GFZ_files\backup\MetaAssets" 29


SetOutPath $INSTDIR\MetaAssets
File /a /r Shiplist\*.*
SetOutPath $INSTDIR\Assets\Specs
File /a /r Shiplist\*.*
SetOutPath $INSTDIR\Assets
File /a /r Scripts

SetOutPath $INSTDIR
CreateDirectory "$INSTDIR\GFZ_files\mod"
CreateDirectory "$INSTDIR\GFZ_files\mod\Origlist"
CreateDirectory "$INSTDIR\GFZ_files\mod\Assets"
CreateDirectory "$INSTDIR\GFZ_files\mod\Assets\Specs"
CreateDirectory "$INSTDIR\GFZ_files\mod\MetaAssets"

CreateDirectory "$INSTDIR\GFZ_files\update"

SetOutPath $INSTDIR\GFZ_files\mod\Origlist
File /a /r Origlist\*.*
SetOutPath $INSTDIR\GFZ_files\mod\MetaAssets
File /a /r Shiplist\*.*
SetOutPath $INSTDIR\GFZ_files\mod\Assets\Specs
File /a /r Shiplist\*.*
#SetOutPath $INSTDIR\GFZ_files\mod\Assets
#File /a /r Scripts
SetOutPath $INSTDIR\GFZ_files\mod
File /a gfz.bmp

WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GFZ" "DisplayName" "GFZ Setup"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GFZ" "UninstallString" '"$INSTDIR\GFZ_Uninstall.exe"'

WriteRegStr HKLM "Software\Bonk\GFZ" "InstallLocation" "$INSTDIR"
WriteRegStr HKLM "Software\Bonk\GFZ" "Version" "1.0"

SetOutPath $INSTDIR
WriteUninstaller "GFZ_Uninstall.exe"
System::Call 'kernel32::GetModuleFileNameA(i 0, t .R0, i 1024) i r1'
CopyFiles $R0 $INSTDIR
CreateDirectory "$SMPROGRAMS\GFZ"
CreateShortCut "$SMPROGRAMS\GFZ\GFZ Setup.lnk" "$INSTDIR\GFZ.exe"

SetOutPath $INSTDIR

DetailPrint "Installation successful."
DetailPrint "Mod activated."
Goto Finished_install

GFZ_installed:
DetailPrint "Error: GFZ already installed!"
MessageBox MB_OK|MB_ICONSTOP "Error: GFZ already installed! Please uninstall the current version if you wish to reinstall." IDOK Finished_install

Finished_install:


SectionEnd 




Section /o "Update" g1o2

SectionIn 2
ReadRegStr $is_installed HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GFZ" "DisplayName"
StrCmp $is_installed "GFZ Setup" GFZ_installed GFZ_not_installed
GFZ_installed:
NSISdl::download http://www.dynaverse.net/webmap_op/nsis-patches/GFZ/patch.pat "$INSTDIR\GFZ_files\update\patch.pat"
Pop $R0
  StrCmp $R0 "success" +4
    MessageBox MB_OK|MB_ICONSTOP "Download failed: $R0"
    DetailPrint "Download failed!"
    Goto Finished_update
DetailPrint "Download successful."
DetailPrint "Patching shiplist..."
vpatch::vpatchfile "$INSTDIR\GFZ_files\update\patch.pat" "$INSTDIR\GFZ_files\mod\Origlist\shiplist.txt" "$INSTDIR\GFZ_files\update\shiplist_new.txt"
  Pop $R0
  DetailPrint "Shiplist patch result: $R0"
DetailPrint "Patching fighterlist..."
vpatch::vpatchfile "$INSTDIR\GFZ_files\update\patch.pat" "$INSTDIR\GFZ_files\mod\Origlist\ftrlist.txt" "$INSTDIR\GFZ_files\update\ftrlist_new.txt"
  Pop $R0
  DetailPrint "Fighterlist patch result: $R0"

IfFileExists "$INSTDIR\GFZ_files\update\shiplist_new.txt" +1 +6
Rename "$INSTDIR\GFZ_files\update\shiplist_new.txt" "$INSTDIR\GFZ_files\update\shiplist.txt"
CopyFiles "$INSTDIR\GFZ_files\update\shiplist.txt" "$INSTDIR\GFZ_files\mod\Assets\Specs"
CopyFiles "$INSTDIR\GFZ_files\mod\Assets\Specs\shiplist.txt" "$INSTDIR\GFZ_files\mod\MetaAssets"
CopyFiles "$INSTDIR\GFZ_files\mod\Assets\Specs\shiplist.txt" "$INSTDIR\Assets\Specs"
CopyFiles "$INSTDIR\GFZ_files\mod\MetaAssets\shiplist.txt" "$INSTDIR\MetaAssets"

IfFileExists "$INSTDIR\GFZ_files\update\ftrlist_new.txt" +1 +6
Rename "$INSTDIR\GFZ_files\update\ftrlist_new.txt" "$INSTDIR\GFZ_files\update\ftrlist.txt"
CopyFiles "$INSTDIR\GFZ_files\update\ftrlist.txt" "$INSTDIR\GFZ_files\mod\Assets\Specs"
CopyFiles "$INSTDIR\GFZ_files\mod\Assets\Specs\ftrlist.txt" "$INSTDIR\GFZ_files\mod\MetaAssets"
CopyFiles "$INSTDIR\GFZ_files\mod\Assets\Specs\ftrlist.txt" "$INSTDIR\Assets\Specs"
CopyFiles "$INSTDIR\GFZ_files\mod\MetaAssets\ftrlist.txt" "$INSTDIR\MetaAssets"

Delete "$INSTDIR\GFZ_files\update\*.*"
DetailPrint "Patch attempted (see results above)."
DetailPrint "Mod activated."
Goto Finished_update
GFZ_not_installed:
DetailPrint "Error: GFZ not installed! Cannot update!"
MessageBox MB_OK|MB_ICONSTOP "Error: GFZ not installed! Cannot update!" IDOK Finished_update
Finished_update:

SectionEnd


Section /o "Activate" g1o3

SectionIn 3
ReadRegStr $is_installed HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GFZ" "DisplayName"
StrCmp $is_installed "GFZ Setup" GFZ_installed GFZ_not_installed
GFZ_installed:
CopyFiles "$INSTDIR\GFZ_files\mod\Assets\Specs\shiplist.txt" "$INSTDIR\Assets\Specs"
CopyFiles "$INSTDIR\GFZ_files\mod\Assets\Specs\ftrlist.txt" "$INSTDIR\Assets\Specs"
CopyFiles "$INSTDIR\GFZ_files\mod\MetaAssets\shiplist.txt" "$INSTDIR\MetaAssets"
CopyFiles "$INSTDIR\GFZ_files\mod\MetaAssets\ftrlist.txt" "$INSTDIR\MetaAssets"
DetailPrint "Mod activated."
Goto Finished_activation
GFZ_not_installed:
DetailPrint "Error: GFZ not installed! Cannot activate!"
MessageBox MB_OK|MB_ICONSTOP "Error: GFZ not installed! Cannot activate!" IDOK Finished_activation
Finished_activation:

SectionEnd


Section /o "Deactivate" g1o4

SectionIn 4
ReadRegStr $is_installed HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GFZ" "DisplayName"
StrCmp $is_installed "GFZ Setup" GFZ_installed GFZ_not_installed
GFZ_installed:
CopyFiles "$INSTDIR\GFZ_files\backup\Assets\Specs\shiplist.txt" "$INSTDIR\Assets\Specs"
CopyFiles "$INSTDIR\GFZ_files\backup\Assets\Specs\ftrlist.txt" "$INSTDIR\Assets\Specs"
CopyFiles "$INSTDIR\GFZ_files\backup\MetaAssets\shiplist.txt" "$INSTDIR\MetaAssets"
CopyFiles "$INSTDIR\GFZ_files\backup\MetaAssets\ftrlist.txt" "$INSTDIR\MetaAssets"
DetailPrint "Mod deactivated."
Goto Finished_deactivation
GFZ_not_installed:
DetailPrint "Error: GFZ not installed! Cannot deactivate!"
MessageBox MB_OK|MB_ICONSTOP "Error: GFZ not installed! Cannot deactivate!" IDOK Finished_deactivation
Finished_deactivation:

SectionEnd


Section /o "Uninstaller" g1o5

SectionIn 5
ReadRegStr $is_installed HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GFZ" "DisplayName"
StrCmp $is_installed "GFZ Setup" GFZ_installed GFZ_not_installed
GFZ_installed:
Exec '"$INSTDIR\GFZ_Uninstall.exe"'
DetailPrint "Uninstaller launched."
Goto Finished_uninstall
GFZ_not_installed:
DetailPrint "Error: GFZ not installed! Cannot uninstall!"
MessageBox MB_OK|MB_ICONSTOP "Error: GFZ not installed! Cannot uninstall!" IDOK Finished_uninstall
Finished_uninstall:
SetAutoClose true

SectionEnd




Section "Uninstall"

CopyFiles "$INSTDIR\GFZ_files\backup\Assets\Specs\*.txt" "$INSTDIR\Assets\Specs"
CopyFiles "$INSTDIR\GFZ_files\backup\MetaAssets\*.txt" "$INSTDIR\MetaAssets"
RMDir /r "$INSTDIR\GFZ_files"
DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GFZ"
DeleteRegKey HKLM "Software\Bonk\GFZ"
Delete "$SMPROGRAMS\GFZ\*.*"
RMDir "$SMPROGRAMS\GFZ"
Delete "$INSTDIR\GFZ_Uninstall.exe"
Delete "$INSTDIR\GFZ.exe"
DetailPrint "Uninstallation successful."

SectionEnd


Function .onInit

 System::Call 'kernel32::CreateMutexA(i 0, i 0, t "BonkD2CampaignInstaller") i .r1 ?e'
 Pop $R0
 
 StrCmp $R0 0 +3
   MessageBox MB_OK|MB_ICONEXCLAMATION "The installer is already running."
   Abort

 Push $R1
 ReadRegStr $R1 HKLM "SOFTWARE\Taldren\Starfleet Command Orion Pirates" "Directory"
 StrCmp $R1 "" +1 +3
  MessageBox MB_OK|MB_ICONEXCLAMATION "SFC:OP not installed!"
  Abort

 StrCpy $INSTDIR $R1
 Pop $R1

 Push $R1
 ReadRegStr $R1 HKLM "SOFTWARE\FireSoul\opplus" "version"
 StrCmp $R1 "4.0" +3 +1
  MessageBox MB_OK|MB_ICONEXCLAMATION "OP+ 4.0 not installed!"
  Abort

 Pop $R1

  StrCpy $1 ${g1o1}

FunctionEnd


Function .onGUIInit

 InitPluginsDir
 File /oname=$PLUGINSDIR\background.bmp "gfz.bmp"
 BgImage::SetBg /NOUNLOAD /FILLSCREEN $PLUGINSDIR\background.bmp
 #BgImage::SetBg /NOUNLOAD /GRADIENT 0 0 0 0x66 0x2D 0x91
 #BgImage::AddImage /NOUNLOAD $PLUGINSDIR\background.bmp 150 0
 #CreateFont $R0 "Arial" 36 700
 #BgImage::AddText /NOUNLOAD "The Gas Free Zone" $R0 0x66 0x2D 0x91 48 48 798 198
 BgImage::Redraw /NOUNLOAD

FunctionEnd

Function un.onGUIInit
 #InitPluginsDir
 #File /oname=$PLUGINSDIR\background.bmp "gfz.bmp"
 #BgImage::SetBg /NOUNLOAD /FILLSCREEN $PLUGINSDIR\background.bmp
 BgImage::SetBg /NOUNLOAD /FILLSCREEN $INSTDIR\GFZ_files\mod\gfz.bmp
 BgImage::Redraw /NOUNLOAD
FunctionEnd



Function skipDirectory

ReadRegStr $is_installed HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GFZ" "DisplayName"
StrCmp $is_installed "GFZ Setup" +1 +6
 Push $R1
 ReadRegStr $R1 HKLM "Software\Bonk\GFZ" "InstallLocation"
 StrCpy $INSTDIR $R1
 Pop $R1
 Abort

FunctionEnd



Function skipLicense

ReadRegStr $is_installed HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\GFZ" "DisplayName"
StrCmp $is_installed "GFZ Setup" +1 +2
 Abort

FunctionEnd

Function .onSelChange

  !insertmacro StartRadioButtons $1
    !insertmacro RadioButton ${g1o1}
    !insertmacro RadioButton ${g1o2}
    !insertmacro RadioButton ${g1o3}
    !insertmacro RadioButton ${g1o4}
    !insertmacro RadioButton ${g1o5}
  !insertmacro EndRadioButtons
	
FunctionEnd

Function .onGUIEnd
	BgImage::Destroy
FunctionEnd

Function un.onGUIEnd
	BgImage::Destroy
FunctionEnd